function [theta,phi, psi,per_t,per_v,filtered_idx_v,filtered_idx_t] = Retrain_LDA_dynamic(iter_max_train,train_visual,train_textual, K,C,T, alpha,beta,gamma, filtered_idx_v, filtered_idx_t)
D = length(train_visual); %%%% training document size
disp(['Training document size is ', num2str(D)]);

tic;
disp('start initial training process');
[M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,len_dv,len_dt,topic_v_d,topic_t_d] = initTrain(D,train_visual,train_textual, K,C,T, alpha,beta,gamma);
toc;
disp('initialzation for training completed.');


disp('start inference process');
iter = 1;
iter_freq = 10;
differ_perplexity = 10^8;
thresh_diff_perplexity = 0.1;
per_all_last = differ_perplexity;
count=1;
% filtered_idx_v = [];
% filtered_idx_t = [];
% while(length(filtered_idx_v)<1000 ||length(filtered_idx_t)<100)
while (iter <=iter_max_train)&&(differ_perplexity > thresh_diff_perplexity)
    disp(['iteration ',num2str(iter)]);
    tic;
    [M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,topic_v_d,topic_t_d] = inference(filtered_idx_v, filtered_idx_t,D,K,M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,len_dv,len_dt,train_visual,train_textual,topic_v_d,topic_t_d,alpha);
    if(mod(iter,iter_freq)==1)
        [per_t(count),per_v(count),per_all] = Cal_perplexity(D,M_D_K,N_D_K,M_K_C,N_K_T,train_visual,train_textual,alpha,filtered_idx_v, filtered_idx_t);

        count = count+1;
        differ_perplexity = abs(per_all_last-per_all);
        per_all_last = per_all;
    end
    toc;
    iter = iter+1;
end
disp('inference process completed.');

theta = findTheta(M_D_K,alpha);
phi = findPhi(M_K_C);
psi = findPsi(N_K_T);
end