function[N_K_T,N_D_K,sum_zt,filtered_idx_t] = filtering_t(K,D, N_K_T,topic_t_d,N_D_K,sum_zt,train_textual,filtered_idx_t)


count_t = sum(N_K_T,1);

p_k_t = N_K_T./count_t;
     

Entropy = p_k_t.*log(p_k_t.^(-1));
Entropy(isnan(Entropy)) = 0;

Entropy = sum(Entropy,1);
[value, index] = sort(Entropy,'descend');

thresh1 = length(find(value>0.99*max(Entropy)));
thresh2 = 0.01*size(N_K_T,2);
% 
thresh = min(thresh1, thresh2);
% thresh = 2;

filtered_idx = index(1:thresh);

filtered_idx_t = cat(2, filtered_idx_t, filtered_idx);

sum_zt = sum_zt - sum(N_K_T(:,filtered_idx),2); 
N_K_T(:,filtered_idx) = 0;

for d = 1:D
    current_dt = train_textual{d};
    current_dt_one_hot = zeros(1,size(N_K_T,2));
    current_dt_one_hot(current_dt)=1; %%%% unique words
    filtered_idx_one_hot = zeros(1,size(N_K_T,2));
    filtered_idx_one_hot(filtered_idx)=1;
    temp = current_dt_one_hot.*filtered_idx_one_hot;    
    matching = find(temp==1);
    [position,~,~] = find( current_dt == matching);
    
    corresponding_topics = topic_t_d{d}(position);
    corresponding_topics = sort(corresponding_topics);
    un_co_t = unique(corresponding_topics);
    for t = 1:length(un_co_t)
        N_D_K(d,un_co_t(t)) = N_D_K(d,un_co_t(t)) - length(find(corresponding_topics==un_co_t(t)));
    end
%     
    
end



end