clear all;
close all;
clc;

% number of topic
K = 20;
% visual words vocabulary size
C =1600;
% textual words vocabulary size
T =160;

%setting for hyper-parameters
alpha = 0.1; %%% hyper-para for theta
gamma = 0.1; %%% hyper-para for textual words
beta = 0.1; %%% hyper-para for visual words


% max training/testing iterations 
iter_max_train = 100;
iter_max_test = 20;


file_path = './dataset/syn/noise/';


train_visual = readfiletxt ([file_path,'p_train_visual']);
train_textual = readfiletxt ([file_path,'p_train_textual']);

% [theta,phi, psi,per_t,per_v,filtered_idx_v,filtered_idx_t] = Retrain_LDA_dynamic(iter_max_train,train_visual,train_textual, K,C,T, alpha,beta,gamma, filtered_idx_v, filtered_idx_t)
[theta,phi, psi,per_t,per_v,filtered_idx_v,filtered_idx_t] = Train_LDA_dynamic(iter_max_train,train_visual,train_textual, K,C,T, alpha,beta,gamma);


test_visual = readfiletxt ([file_path,'p_test_visual']);
test_textual = readfiletxt ([file_path,'p_test_textual']);


[theta_test,phi_test, psi_test,per_t_test,per_v_test] = Test_LDA(iter_max_test,test_visual,test_textual, alpha, beta, gamma, phi, psi,filtered_idx_v,filtered_idx_t );

[scores,gold_rank, err_rate_retrain] = retrieval(test_textual, theta_test, psi_test,filtered_idx_t);




